/*

  Autor(s)      : Jordi Ferrer Plana
  e-mail        : jferrerp@eia.udg.es
  Especialitat  : Computadors

  Project       : Practiques de computadors
  Homepage      : http://eia.udg.es/~jferrerp

  Modul         : Definicio d'una Cua Estatica

  Fitxer        : tcua.h
  Data          : 27/03/2003 - 28/03/2003

  Compilador    : Micro Series 8051 C-Compiler V4.23C/DXT (IAR Systems 1992)
  Llibreries    :

  Notes         : - La cua es estatica. Es pot definir la mida maxima per totes
                    les cues que es declarin redefinint TCUA_MAX_ELEMENTS.
                  - El contingut d'una posicio de la cua tambe es pot redefinir
                    amb TCUA_Element.
                  - Sempre cal cridar a TCUA_Crer() per inicialitzar una cua.

 ----------------------------------------------------------------------------

     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version. See COPYING for more information.

 ----------------------------------------------------------------------------
*/

#ifndef __TCUA_H__
#define __TCUA_H__

#define TCUA_MAX_ELEMENTS  25              /* Mida maxima estatica de la cua */
typedef unsigned char      TCUA_Element;   /* Tipus d'element que conte la cua */

typedef struct                             /* Estructura del tipus */
{
   TCUA_Element   Dada[TCUA_MAX_ELEMENTS]; /* Buffer on es guardes les dades */
   unsigned int   Punter_Inici;            /* Punter a l'inici */
   unsigned int   Punter_Fi;               /* Punter a la cua */
   unsigned char  Buida;                   /* Boolea que indica buida */
} TCua;

/* Metodes del T.A.D. */
void         TCUA_Crear     ( TCua *Cua );
bit          TCUA_Buida     ( TCua *Cua );
bit          TCUA_Plena     ( TCua *Cua );
void         TCUA_Encuar    ( TCua *Cua, TCUA_Element Dada );
void         TCUA_Desencuar ( TCua *Cua );
TCUA_Element TCUA_Primer    ( TCua *Cua );

#endif
