/*

  Autor(s)      : Jordi Ferrer Plana
  e-mail        : jferrerp@eia.udg.es
  Especialitat  : Computadors

  Project       : Practiques de computadors
  Homepage      : http://eia.udg.es/~jferrerp

  Modul         : Programa de test d'una Cua Estatica

  Fitxer        : tcua.h
  Data          : 27/03/2003 - 28/03/2003

  Compilador    : Micro Series 8051 C-Compiler V4.23C/DXT (IAR Systems 1992)
  Llibreries    :

  Notes         : -

 ----------------------------------------------------------------------------

     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version. See COPYING for more information.

 ----------------------------------------------------------------------------
*/
#include <stdio.h>   /* printf */
#include <io51.h>
#include "tcua.h"    /* Incloure la definicio */

xdata TCua Cua;      /* Una cua global i a memoria externa */

/* Configurar Serie */
void InitRS232 ( void )
{
  unsigned char Buffer;

  Buffer = PCON;
  Buffer &= 0x7F;
  PCON   = Buffer;
  TH1    = 0x0FD;
  TL0    = 0x0FD;
  TMOD   = 0x20;
  TCON   = 0x40;
  SCON   = 0x52;
}

void main ( )
{
  unsigned char Valor;                        /* Variable local */

  InitRS232 ( );

  printf ( "Crear...\n" );
  TCUA_Crear ( &Cua );                        /* Crear una Cua */

  T1 = T0 = INT1 = P1.2 = 1;
  Valor = ' ';

  printf ( "Encuar...\n" );
  while ( Valor <= 'z' )                      /* Posar uns quants caracters */
  {
     TCUA_Encuar ( &Cua, Valor );             /* Encuar Valor */
     printf ( "[%c]", Valor );
     Valor++;                                 /* Nou valor */
  }

  printf ( "\n" );

  T1 = T0 = INT1 = P1.2 = 0;
  printf ( "Desencuar...\n" );
  while ( !TCUA_Buida ( &Cua ) )              /* Mentre quedin valors a la cua */
  {
      Valor = TCUA_Primer ( &Cua );
      printf ( "[%c]", Valor );               /* Escriure el valor al port serie */
      TCUA_Desencuar ( &Cua );                /* Desencuar el valor enviat */
  }

  printf ("\n");

  T1 = T0 = INT1 = P1.2 = 1;
  printf ( "Fi!" );
}
